# kare 使用说明
## 简介
&emsp;&emsp; KARE是一种让用户能够在 Linux 桌面系统上运行适配于其他 Linux 桌面系统应用的兼容环境，它能够解决兼容性问题，提高软件的可用性和可靠性。
&emsp;&emsp; KARE出现的主要目的是解决基于 Linux 桌面系统开发的软件在其他 Linux 桌面系统操作系统上无法正常运行的问题。KARE通过模拟目标软件的操作系统环境，使软件可以在当前系统上正常运行，从而避免了因为软件不兼容而导致的应用崩溃和数据丢失等问题。
## 如何安装 kare
通过 dpkg 或 apt 安装 kare 软件包后即可使用

## 通过 kare 安装软件包
### 通过 shell 命令安装
#### 基本命令
kare -e \$runEnv -i \${softwareName}\_\${version}\_\${arch}.deb
或 kare -e \$runEnv install \${softwareName}\_\${version}\_\${arch}.deb
#### 命令解释
在宿主机上，安装适配于 runEnv 的软件包 softwareName_version_arch.deb
#### 注意事项
1. -e 在前, -i | install 在后
2. -e 可选项如下（区分空格, 不区分大小写）
    ubuntu16.04         ubuntu18.04         ubuntu20.04         ubuntu22.04         
    v4                  v10                 v10sp1              
    openkylin1.0        openkylin2.0
3. 软件包名符合"softwareName_version_arch.deb"命名规范, 即下划线有且仅有两个，软件包名、版本号和架构以下划线为界
### 通过调用 dbus 接口安装
#### 接口说明
服务名称: org.kylin.kare
对象路径: /org/kylin/kare
接口名称: org.kylin.kare
方法名称: bool install(string \$runEnv, string \${softwareName}\_\${version}\_\${arch}.deb)

## 列出通过 kare 安装的软件包
### 基本命令
kare -l 或 kare list

## 列出已安装软件包的包文件
### 基本命令
kare -L $softwareName

## 搜索文件所属软件包及文件路径
### 基本命令
kare -S $filename

## 列出通过 kare 构建的兼容运行环境
### 基本命令
kare -E

## 卸载
### 通过调用 dbus 接口卸载
#### 基本命令
1. kare -r \$softwareName \$version 或 kare remove \$softwareName \$version
2. kare -P \$softwareName
#### 命令解释
1. 卸载指定版本号的软件包
2. 卸载所有名为 softwareName 的软件包
### 通过调用 dbus 接口卸载
#### 接口说明
服务名称: org.kylin.kare
对象路径: /org/kylin/kare
接口名称: org.kylin.kare
方法名称: bool remove(string \$softwareName)

## 运行
通过 kare 安装的软件包，一般都会有 Desktop 文件作为该软件包的启动入口，该文件位于桌面或开始菜单；亦可以通过 shell 命令运行
### 基本命令
kare run <参数>
### 注意事项
1. 升级/换机场景
- 默认情况下是“以兼容模式”运行此应用, 即双击桌面图标或开始菜单图标时将以兼容模式打开
- 右键桌面图标，选择“以兼容模式打开”后，用户可以选择此应用的运行环境，并可以选择是否记住此模式（记住运行环境和兼容运行模式）
- shell 命令示例: 
kare run RichR \${exec} \${runEnv} rightclick
    - ${exec} 为相应软件包的可执行文件路径
    - ${runEnv} 为运行相应可执行文件的环境，如 ubuntu16.04
2. 其他场景
- 通过 kare 安装的应用，永久是以兼容模式打开
- shell 命令示例: 
kare run \${softwareName}\_\${softwareVersion} \${exec}
    - \${softwareName}\_\${softwareVersion} 可通过 kare -l 查看并手动拼接
    - ${exec} 为相应软件包的可执行文件路径

## 帮助
### 基本命令
kare -h