import subprocess
import re
import sys
import subprocess
import os
import threading

class KareApt():

    def __init__(self, deb):
        self.whitelist_package={
            "biometric-driver-huahom-im20u": ["biometric-driver-community-multidevice"],
            "semaisystem": ["libglu1-mesa"],
            "wpsoffice": ["libglu1-mesa"],
            "redisplus": ["xdg-utils"],
            "deli-printer-a113":["libsane1"],
            "founder-ofdreader":["libgtk2.0-bin"],
            "founder-cebreader":["libgtk2.0-bin"],
            "founder-doceditor":["libgtk2.0-bin"],
            "gstarcad":["mate-terminal"],
            "gstararch2024":["mate-terminal"],
            "gstarsoft.gstarcad2025":["mate-terminal"],
            "gstarmechcad":["mate-terminal"],
            "gstarhvac2024":["mate-terminal"],
            "gstarwt2024":["mate-terminal"],
            "hatari":["python-gtk2-dev"],
            "pyhoca-gui":["python-cups"],
            "classicmenu-indicator":["python3-pkg-resources"],
            "pycorrfit":["python-pkg-resources"],
            "subdownloader":["python-qt4"],
            "knetwalk":["qml-module-org-kde-games-core","qml-module-qtquick2"],
            "gnome-twitch":["gstreamer1.0-plugins-base"],
            "gtranscribe":["gstreamer1.0-plugins-good"],
            "gstarcad2022":["mate-terminal"],
            "gstarelec2024":["mate-terminal"],
            "gstarcad2023":["mate-terminal"],
            "yozo-office.s1":["mate-terminal"],
            "com.watchdata.authtool":["openjdk-11-jre"],
            "spview":["openjdk-11-jre"],
            "gespeaker":["python-dbus"],
            "pycode-browser":["python-gobject"],
            "gpxviewer":["python-gobject", "python-cairo"],
            "quitcount":["at-spi2-core"],
            "subdownloader":["python-qt4"],
            "com.foxit.foxitpdfeditor":["libxcb-composite0", "libxcb-damage0"],
            "clementine":["libqt5sql5-sqlite"],
            "cmclient":["libwebkit2gtk-4.0-37"],
            "cn.hitecloud.hitecamera":["libatlas3-base", "libsndio7.0", "libxss1"],
            "cn.lanxin":["libxss1"],
            "com.cltsvr":["libcurl4"],
            "com.wendouscanner":["libv4l-0"],
            "i4tools":["libcdio-paranoia2", "libcaca0", "libraw1394-1", "libavc1394-0", "libiec61883-0", "libsodium23"],
            "kirigami-gallery":["qml-module-qtquick-layouts"],
            "lollypop":["gstreamer1.0-plugins-good"],
            "linphone-desktop":["qml-module-qtqml-models2", "qml-module-qtquick-controls", "qml-module-qtquick-controls2", "qml-module-qtquick-dialogs", "qml-module-qtquick-layouts", "qml-module-qtquick-privatewidgets", "qml-module-qtquick-shapes", "qml-module-qtquick-templates2", "qml-module-qtquick-window2", "qml-module-qtquick2"],
            "kphotoalbum":["libnotify-bin"],
            "marble-maps":["kirigami-gallery"],
            "navicat":["fuse3"],
            "net.zhuoaninfo.pdf417.creator":["openjdk-11-jdk"],
            "pragha":["gstreamer1.0-plugins-good"],
            "rededa":["libarchive13"],
            "redis-desktop-manager":["qml-module-qtquick-controls2"],
            "spview":["openjdk-11-jdk"],
            "teamspeak":["libpci3"]
        }
        # TODO v10 v10-sp1 做区分
        RELEASE = subprocess.getoutput("cat /etc/lsb-release | grep DISTRIB_DESCRIPTION | awk -F '=' '{print $2}'").strip("\"")
        if RELEASE == "Kylin V10":
            self.blacklist = ["libqt5gui5-gles", "libqt5quick5-gles", "libqt5quickparticles5-gles", "kde-cli-tools", "libjack0", "libglu1","libqt5quickwidgets5-gles", "ubuntu-mate-default-settings", "mint-mate-default-settings", "libqt5multimediawidgets5-gles", "libavcodec-ffmpeg-extra56", "libqt5opengl5-gles", "mplayer2", "erlang-base-hipe"]
        else:
            self.blacklist = ["libqt5gui5-gles", "libqt5quick5-gles", "libqt5quickparticles5-gles", "kde-cli-tools", "kde-runtime", "libjack0", "libglu1"]
        self.depends_version_dict = {}
        self.apt_list=[]
        self.deb = deb
        self.log = deb.rsplit("/")[-1] + "_log"
        
    def tail(self):
        os.system('touch /var/{}'.format(self.log))
        os.system('tail -f /var/{}'.format(self.log))

    def lower_apt(self, target, version):
        for T in target.split("\n"):
            if T.strip().startswith("500"):
                continue
            else:
                now = T.strip().strip("*** ").split("500")[0].strip()
                ret = subprocess.getoutput("dpkg --compare-versions {} le {} && echo True".format(now, version.strip("<").strip("=")))
                if ret == "True":
                    return now
        else:
            return False

    def apt(self, deb):
        ret = subprocess.getoutput('DEBIAN_FRONTEND=noninteractive apt-get -f install -y {} -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" | tee -a /var/{} '.format(deb, self.log))
        if "下列软件包有未满足的依赖关系：" in ret:
            for i in ret.split("下列软件包有未满足的依赖关系：")[-1].strip().split("\n")[0:-1]:
                if "依赖" in i:
                    depend = i.split("依赖: ")[-1].split(" ")[0].strip()
                    try:
                        version = re.findall(r'\((.*?)\)', i)[0]
                    except IndexError:
                        version = ">"
                    if version.startswith(">"):
                        self.apt(depend)
                    elif version.startswith("<"):
                        policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
                        ver = self.lower_apt(policy, version)
                        if ver:
                            self.apt(depend+"="+ver)
                    else:
                        x = subprocess.getoutput("apt-cache policy {} | grep '{}'\ ".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
                        self.apt(depend+"="+x)
                elif "冲突" in i:
                    depend = i.split("冲突: ")[-1].split(" ")[0].strip()
                    try:
                        version = re.findall(r'\((.*?)\)', i)[0]
                    except IndexError:
                        version = ">"
                    if version.startswith(">"):
                        self.apt(depend)
                    elif version.startswith("<"):
                        policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
                        ver = self.lower_apt(policy, version)
                        if ver:
                            self.apt(depend+"="+ver)
                    else:
                        x = subprocess.getoutput("apt-cache policy {} | grep '{}'\ ".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
                        self.apt(depend+"="+x)
            os.system('DEBIAN_FRONTEND=noninteractive apt-get -f install -y {} -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" '.format(deb))
        elif "在处理时有错误发生：" in ret or "无法找到文件 - " in ret and "错误:" in ret:
            sys.exit(-1)

    def set_depend_version(self, depend, version):
        if depend.strip() in self.blacklist:
            return
        if version is None:
            policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
            if policy:
                self.depends_version_dict.setdefault(depend, None)
            return
        if version.startswith(">"):
            policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
            if policy:
                self.depends_version_dict.setdefault(depend, None)
            return
        elif version.startswith("<"):
            #TODO set version
            policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
            ver = self.lower_apt(policy, version)
            if ver:
                self.depends_version_dict[depend] = ver
            return  
        else:
            x = subprocess.getoutput("apt-cache policy {} | grep '{}'".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip().split("\n")[-1].strip()
            self.depends_version_dict.setdefault(depend, x)
            return

    def get_deb_depends_version(self, debs):
        for i in debs:
            v = None
            pkg = i.strip()
            if "|" in pkg:
                pkgs = pkg.split("|")
                for p in pkgs:
                    version = None
                    if "(" in p:
                        p = p.split("(")[0].strip()
                        version = re.findall(r'\((.*?)\)', i)[0]
                    self.set_depend_version(p, version)
            elif "(" in pkg:
                pkg= pkg.split("(")[0].strip()
                version = re.findall(r'\((.*?)\)', i)[0]
                self.set_depend_version(pkg, version)
            else:
                self.set_depend_version(pkg, v)

    def build_apt(self):
        for depends in self.depends_version_dict:
            if self.depends_version_dict[depends] is None or self.depends_version_dict[depends] == "":
                self.apt_list.append(depends)
            else:
                 self.apt_list.append("{}={}".format(depends, self.depends_version_dict[depends]))
         

    def get_deb_depends(self):
        # 依赖包安装
        package = subprocess.getoutput("dpkg -I {} | grep Package".format(self.deb)).split(" Package:")[-1].strip()
        if self.whitelist_package.get(package):
            self.apt(" ".join(self.whitelist_package.get(package)))
        debs = subprocess.getoutput("dpkg -I {} | grep Depends".format(self.deb)).split(" Depends:")[-1].split(",")
        self.get_deb_depends_version(debs)
        pre_debs = subprocess.getoutput("dpkg -I {} | grep Pre-Depends".format(self.deb)).split(" Pre-Depends:")[-1].split(",")
        self.get_deb_depends_version(pre_debs)
        self.build_apt()
        # os.system("apt-get install -s -y {}".format(" ".join(self.apt_list)))
        self.apt(" ".join(self.apt_list))
        subprocess.getoutput("apt-get install -f -y")
        # 目标包安装
        ret = os.system('SYSTEMD_IGNORE_CHROOT=1 DEBIAN_FRONTEND=noninteractive dpkg --force-confdef --force-confold -i {} '.format(self.deb))
        # ret = os.system('SYSTEMCTL_FORCE_BUS=1 SYSTEMD_IGNORE_CHROOT=1 DEBIAN_FRONTEND=noninteractive dpkg --force-confdef --force-confold -i {} '.format(self.deb))
        if ret != 0:
            sys.exit(-1)
        else:
            sys.exit()

kare = KareApt(sys.argv[1])

p1 = threading.Thread(target=kare.tail, args=()) 
p1.daemon = True
p1.start()  
kare.get_deb_depends()
sys.exit()

