# KARE

## 版本计划

【V2.0】
1. 支持 V10 升级 SP1 场景中，SP1 系统可兼容运行 V10 应用

【V2.1】
1. 支持系统跨大版本升级后，高版本系统运行低版本图形应用
2. 支持构建 V10、V10 SP1、Ubuntu 16.04、openKylin 1.0 兼容运行环境
3. 通过 KARE 安装的应用，可被宿主机中的 dpkg 同步管理
4. 用户可以指定应用程序长期以 KARE 模式运行；安装在 KARE 中的应用默认长期采用 KARE 模式运行
5. 支持用户可以自主选择程序所使用的运行环境；安装在 KARE 中的应用不支持
6. 支持用户可以勾选或取消应用程序兼容运行选项，安装在 KARE 中的应用不支持
7. 支持通过命令行的形式将 Deb 软件包安装至 KARE 环境中，并支持用户可自主选择安装至哪个兼容环境中
8. 当有应用安装在 KARE 中时，KARE 不可被卸载
9. 通过 KARE 运行的应用，支持使用宿主机中的输入法
10. 通过KARE运行的应用，支持使用宿主机中的文件管理器
11. 通过KARE运行的应用，支持访问与使用硬件外设
12. 通过KARE运行的应用，支持注册系统托盘图标、发送系统通知、访问系统剪贴板
13. 通过KARE运行的应用，所产生的的进程/线程支持被宿主机的进程管理所控制
14. 支持 ARM 和 X86 架构
15. 支持 KARE 命令行工具，选项包括
    1) -e：在安装软件包时指定安装环境，如: ubuntu16.04、openkylin1.0等
    2) -i | install：安装软件包
    3) -b：构建基础环境，如：ubuntu16.04、openkylin1.0等
    4) -r | remove：卸载指定版本号的软件包
    5) -P：卸载软件包，若存在多个版本，则一并卸载
    6) -l | list：列出已安装的软件包
    7) -h：列出使用说明
    8) run：运行软件

【V2.2】
1. KARE 支持非图形化后台常驻类应用

【待完成1】
1. KARE 支持 MIME 关联调用
2. KARE 支持访问与修改宿主机中的 Gsettings 配置项
3. KARE 支持多用户环境
4. KARE 支持注册自启动服务
5. KARE 与 KARE、宿主机之间实现可执行文件、服务共享
6. 支持通过麒麟安装包管理器、软件商店、命令行等形式将软件包安装至 KARE 环境中

【待完成2】
1. KARE 支持不可变系统，满足对 V10 及 SP1 图形化应用的安装、卸载、运行及列出等功能
2. KARE 应用图标完成显著标识
3. KARE 安装应用时支持依赖自动检测补齐功能

## 非升级场景中，基础环境、容器镜像名称和系统版本对应关系

|  env name   |     container image   |  system version  |
|  ---------  | --------------------  | --------------   |
| kare-u16    |    baseimage_u16      |    ubuntu16.04   |
| kare-u18    |    baseimage_u18      |    ubuntu18.04   |
| kare-u20    |    baseimage_u20      |    ubuntu20.04   |
| kare-u22    |    baseimage_u22      |    ubuntu22.04   |
| kare-u24    |    baseimage_u24      |    ubuntu24.04   |
| kare-ok1    |    baseimage_ok1      |    openkylin1.0  |
| kare-ok2    |    baseimage_ok2      |    openkylin2.0  |
| kare-v4     |    baseimage_v4       |    v4            |
| kare-v10    |    baseimage_v10      |    v10           |
| kare-v10sp1 |    baseimage_v10sp1   |    v10sp1        |

## 升级场景中，基础环境、容器镜像名称和系统版本对应关系

|  env name     |   container image   |     system version    |
|  -----------  | ------------------  |     --------------    |
| fs.old-u16    |    fsimage_u16      |    ubuntukylin16.04   |
| fs.old-u18    |    fsimage_u18      |    ubuntukylin18.04   |
| fs.old-u20    |    fsimage_u20      |    ubuntukylin20.04   |
| fs.old-u22    |    fsimage_u22      |    ubuntukylin22.04   |
| fs.old-u24    |    fsimage_u24      |    ubuntukylin22.04   |
| fs.old-ok1    |    fsimage_ok1      |    openkylin1.0       |
| fs.old-ok2    |    fsimage_ok2      |    openkylin2.0       |
| fs.old-v4     |    fsimage_v4       |    v4                 |
| fs.old-v7     |    fsimage_v7       |    v7                 |
| fs.old-v10    |    fsimage_v10      |    v10                |
| fs.old-v10sp1 |    fsimage_v10sp1   |    v10sp1             |

## 分支规划
| 分支名称         | 适用场景/功能                            | 状态                    |
| -------         | -----------                            | ------                 |
| kare-GXXC       | 广西信创项目 V10->sp1 升级场景            | 已完成测试并上线          |
| kare-GXXC-mips  | 广西信创项目 V10->sp1 mips升级场景        | 已完成测试并上线          |
| kare            | 适用于全场景的主分支                      | 未测试                  |
| kare-2.0        | kare 2.0 2.1 版本分支                   | 未测试                  |
| kare-2.2        | kare 2.2 版本分支，可发布                | 未测试                  |
| kare-2.2-fat    | kare 2.2 版本的功能测试分支，可提测        | 未测试                  |
| kare-2.2-dev    | kare 2.2 版本的开发分支                  |                        |