import subprocess
import re
import sys
import os
import threading

import shutil  
import logging

from pathlib import Path

vp_ws = "/opt/compatibility_layer/vpws" 

logger = logging.getLogger()
logger.setLevel(logging.DEBUG)

log_file = "/opt/compatibility_layer/logs/encryption.log"
file_handler = logging.FileHandler(log_file)
# formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(message)s')
formatter = logging.Formatter('%(asctime)s - %(levelname)s - %(filename)s:%(lineno)d - %(message)s') 
file_handler.setFormatter(formatter)
logger.addHandler(file_handler)


def pyln(src, des):
    os.system('ln -sf {} {}'.format(src, des))

class Init():
    # def preInit(self):
    #     CLIST = [
    #         "who"
    #         "users"
    #     ]
    #     for each in CLIST:
    #         DES = 
    #         EFile = '/usr/bin/{}'.format(each)
    #         EFileK = EFile + '-kare'
    #         pyln(EFileK, EFile)

    def postInit(self):
        pyln("/usr/bin/hostAgent", "/usr/bin/xdg-open")
        pyln("/usr/bin/hostAgent", "/usr/bin/gvfs-open")
        pyln("/usr/bin/hostAgent", "/usr/bin/gio")
        pyln("/usr/bin/python2", "/usr/bin/python")
        browser_list = [  
            "/usr/bin/firefox",  
            "/usr/bin/firefox-esr",  
            "/usr/bin/google-chrome-stable",  
            "/usr/bin/chromium-browser",  
            "/usr/bin/lbrowser",  
            "/usr/bin/browser360-cn-stable",  
            "/usr/bin/qaxbrowser-safe-stable"  
        ]
        for browser in browser_list:  
            if not os.path.isfile(browser):
                pyln("/usr/bin/hostAgent", browser)
        if not os.path.isdir("/root"):  
            os.system("mkdir /root")

class KareApt():

    def __init__(self, deb):
        self.whitelist_package={
           "biometric-driver-huahom-im20u": ["biometric-driver-community-multidevice"],
            "semaisystem": ["libglu1-mesa"],
            "wpsoffice": ["libglu1-mesa"],
            "redisplus": ["xdg-utils"],
            "deli-printer-a113":["libsane1"],
        }
        self.blacklist = ["libqt5gui5-gles", "libqt5quick5-gles", "libqt5quickparticles5-gles", "kde-cli-tools", "kde-runtime", "libjack0", "libglu1"]
        self.depends_version_dict = {}
        self.apt_list=[]
        self.deb = deb
        self.log = deb.rsplit("/")[-1] + "_log"

    def update(self):
        os.system("apt update")
        
    def tail(self):
        os.system('touch /var/{}'.format(self.log))
        os.system('tail -f /var/{}'.format(self.log))

    def lower_apt(self, target, version):
        for T in target.split("\n"):
            if T.strip().startswith("500"):
                continue
            else:
                # now = T.strip().strip(" 500").strip("*** ")
                now = T.strip().strip("*** ").split("500")[0].strip()
                ret = subprocess.getoutput("dpkg --compare-versions {} le {} && echo True".format(now, version.strip("<").strip("=")))
                if ret == "True":
                    return now
        else:
            return False

    def apt(self, deb):
        ret = subprocess.getoutput('DEBIAN_FRONTEND=noninteractive apt-get -f install -y {} -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" | tee -a /var/{} '.format(deb, self.log))
        if "下列软件包有未满足的依赖关系：" in ret:
            for i in ret.split("下列软件包有未满足的依赖关系：")[-1].strip().split("\n")[0:-1]:
                if "依赖" in i:
                    depend = i.split("依赖: ")[-1].split(" ")[0].strip()
                    try:
                        version = re.findall(r'\((.*?)\)', i)[0]
                    except IndexError:
                        version = ">"
                    if version.startswith(">"):
                        self.apt(depend)
                    elif version.startswith("<"):
                        policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
                        ver = self.lower_apt(policy, version)
                        if ver:
                            self.apt(depend+"="+ver)
                    else:
                        # x = subprocess.getoutput("apt-cache policy {} | grep '{}'".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
                        x = subprocess.getoutput("apt-cache policy {} | grep '{}'\ ".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
                        self.apt(depend+"="+x)
            os.system('DEBIAN_FRONTEND=noninteractive apt-get -f install -y {} -o Dpkg::Options::="--force-confdef" -o Dpkg::Options::="--force-confold" '.format(deb))
        elif "在处理时有错误发生：" in ret or "无法找到文件 - " in ret and "错误:" in ret:
            sys.exit(-1)

    def set_depend_version(self, depend, version):
        if depend.strip() in self.blacklist:
            return
        if version is None:
            policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
            if policy:
                self.depends_version_dict.setdefault(depend, None)
            return
        if version.startswith(">"):
            policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
            if policy:
                self.depends_version_dict.setdefault(depend, None)
            return
        elif version.startswith("<"):
            #TODO set version
            policy = subprocess.getoutput("apt-cache policy {} | grep 500".format(depend))
            ver = self.lower_apt(policy, version)
            if ver:
                self.depends_version_dict[depend] = ver
            return  
        else:
            # x = subprocess.getoutput("apt-cache policy {} | grep '{}'".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip()
            x = subprocess.getoutput("apt-cache policy {} | grep '{}'".format(depend, version.split(" ")[-1])).rsplit("500", 1)[0].strip().split("\n")[-1].strip()
            self.depends_version_dict.setdefault(depend, x)
            return

    def get_deb_depends_version(self, debs):
        for i in debs:
            v = None
            pkg = i.strip()
            if "|" in pkg:
                pkgs = pkg.split("|")
                for p in pkgs:
                    version = None
                    if "(" in p:
                        p = p.split("(")[0].strip()
                        version = re.findall(r'\((.*?)\)', i)[0]
                    self.set_depend_version(p, version)
            elif "(" in pkg:
                pkg= pkg.split("(")[0].strip()
                version = re.findall(r'\((.*?)\)', i)[0]
                self.set_depend_version(pkg, version)
            else:
                self.set_depend_version(pkg, v)

    def build_apt(self):
        for depends in self.depends_version_dict:
            # if self.depends_version_dict[depends] is None:
            if self.depends_version_dict[depends] is None or self.depends_version_dict[depends] == "":
                self.apt_list.append(depends)
            else:
                 self.apt_list.append("{}={}".format(depends, self.depends_version_dict[depends]))
         

    def get_deb_depends(self):
        if not os.path.isdir("/root"):  
            os.system("mkdir /root")
        # 依赖包安装
        package = subprocess.getoutput("dpkg -I {} | grep Package".format(self.deb)).split(" Package:")[-1].strip()
        if self.whitelist_package.get(package):
            self.apt(" ".join(self.whitelist_package.get(package)))
        debs = subprocess.getoutput("dpkg -I {} | grep Depends".format(self.deb)).split(" Depends:")[-1].split(",")
        self.get_deb_depends_version(debs)
        self.build_apt()
        self.apt(" ".join(self.apt_list))
        subprocess.getoutput("apt-get install -f -y")
        # 目标包安装
        # ret = os.system('SYSTEMCTL_FORCE_BUS=1 SYSTEMD_IGNORE_CHROOT=1 DEBIAN_FRONTEND=noninteractive dpkg --force-confdef --force-confold -i {} '.format(self.deb))
        ret = os.system('SYSTEMD_IGNORE_CHROOT=1 DEBIAN_FRONTEND=noninteractive dpkg --force-confdef --force-confold -i {} '.format(self.deb))
        if ret != 0:
            sys.exit(-1)

# if __name__ == "__main__":
#     containerTypeValue = sys.argv[1]
#     containerNameValue = sys.argv[2]
#     pkgName = sys.argv[3]
#     # BWRAP_OPTIONS = sys.argv[4]
#     # srHandle = ServiceManager(containerTypeValue, containerNameValue, pkgName, BWRAP_OPTIONS)
#     # srHandle.serviceRegistration()

#     srvmanager = ResourceManager(containerTypeValue, containerNameValue, pkgName)
#     srvmanager.find_service_files()

