﻿#include <QCoreApplication>
#include <QDBusConnection>
#include <QDebug>
#include "packageDBusManager.h"

int main(int argc, char *argv[])
{
    QCoreApplication a(argc, argv);

    QDBusConnection connection = QDBusConnection::systemBus();
    if (!connection.isConnected())
    {
        qDebug() << "dbus连接失败";
        return -1;
    }
    if (!connection.registerService("org.kylin.kare"))
    {
        qDebug() << "org.kylin.kare 服务注册失败";
        return -1;
    }
    packageDBusManager manager;
    if (!connection.registerObject("/org/kylin/kare", &manager,
                                   QDBusConnection::ExportAllContents))
    {
        qDebug() << "/org/kylin/kare 对象注册失败";
        return -1;
    }
    return a.exec();
}
